<?php
namespace TYPO3\CMS\Backend\Tree;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2010-2013 TYPO3 Tree Team <http://forge.typo3.org/projects/typo3v4-extjstrees>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *  A copy is found in the text file GPL.txt and important notices to the license
 *  from the author is found in LICENSE.txt distributed with these scripts.
 *
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Abstract Tree
 *
 * @author Stefan Galinski <stefan.galinski@gmail.com>
 */
abstract class AbstractTree {

	/**
	 * Data Provider
	 *
	 * @var \TYPO3\CMS\Backend\Tree\AbstractTreeDataProvider
	 */
	protected $dataProvider = NULL;

	/**
	 * Tree Node Decorator
	 *
	 * @var \TYPO3\CMS\Backend\Tree\Renderer\AbstractTreeRenderer
	 */
	protected $nodeRenderer = NULL;

	/**
	 * @param \TYPO3\CMS\Backend\Tree\AbstractTreeDataProvider $dataProvider
	 * @return void
	 */
	public function setDataProvider(\TYPO3\CMS\Backend\Tree\AbstractTreeDataProvider $dataProvider) {
		$this->dataProvider = $dataProvider;
	}

	/**
	 * @return \TYPO3\CMS\Backend\Tree\AbstractTreeDataProvider
	 */
	public function getDataProvider() {
		return $this->dataProvider;
	}

	/**
	 * @param \TYPO3\CMS\Backend\Tree\Renderer\AbstractTreeRenderer $dataProvider
	 * @return void
	 */
	public function setNodeRenderer(\TYPO3\CMS\Backend\Tree\Renderer\AbstractTreeRenderer $nodeRenderer) {
		$this->nodeRenderer = $nodeRenderer;
	}

	/**
	 * @return \TYPO3\CMS\Backend\Tree\Renderer\AbstractTreeRenderer
	 */
	public function getNodeRenderer() {
		return $this->nodeRenderer;
	}

	/**
	 * Returns the root node
	 *
	 * @return \TYPO3\CMS\Backend\Tree\TreeNode
	 */
	abstract public function getRoot();

}
