<?php
namespace TYPO3\CMS\Core\Tests\Unit\Charset;

/***************************************************************
 * Copyright notice
 *
 * (c) 2010-2013 Oliver Klee (typo3-coding@oliverklee.de)
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Testcase for \TYPO3\CMS\Core\Charset\CharsetConverter
 *
 * @author Oliver Klee <typo3-coding@oliverklee.de>
 */
class CharsetConverterTest extends \TYPO3\CMS\Core\Tests\UnitTestCase {

	/**
	 * @var \TYPO3\CMS\Core\Charset\CharsetConverter
	 */
	protected $fixture = NULL;

	public function setUp() {
		$this->fixture = new \TYPO3\CMS\Core\Charset\CharsetConverter();
	}

	////////////////////////////
	// Tests concerning substr
	////////////////////////////
	/**
	 * @test
	 * @see http://forge.typo3.org/issues/22334
	 */
	public function substrForEmptyStringAndNonZeroLengthReturnsEmptyString() {
		$this->assertSame('', $this->fixture->substr('utf-8', '', 0, 42));
	}

	/////////////////////////////////
	// Tests concerning utf8_strlen
	/////////////////////////////////
	/**
	 * @test
	 */
	public function utf8_strlenForNonEmptyAsciiOnlyStringReturnsNumberOfCharacters() {
		$this->assertEquals(10, $this->fixture->utf8_strlen('good omens'));
	}

}
